# TODO nur einmal einlesen

def get_data_types():
    from os import listdir
    from os.path import isfile, join
    import json

    DIR = 'datatypes/'
    files = [ f for f in listdir(DIR) if isfile(join(DIR,f)) ]
    result = []
    for file in files:
        with open(join(DIR,file)) as f:
            try:
                data=json.loads(f.read())['root-type']
                result.append(data)
            except ValueError:
                pass
    return result


def get_field_labels_of_type(type):
    result = []
    fields = get_fields_of_type(type)
    if fields is not None:
        for f in fields:
            result.append(f['label'])
    return result

def get_field_labels_required_of_type(type): # TODO rename
    result = []
    fields = get_fields_of_type(type)
    if fields is not None:
        for f in fields:
            result.append((f['label'],f['required']))
    return result


def get_fields_of_type(type):
    from os import listdir
    from os.path import isfile, join
    import json

    DIR = 'datatypes/'
    files = [ f for f in listdir(DIR) if isfile(join(DIR,f)) ]
    for file in files:
        with open(join(DIR,file)) as f:
            try:
                t = json.loads(f.read())
                if t['root-type'] == type:
                    return t['fields']
            except ValueError:
                pass


def get_field_label(type, key):
    fields = get_fields_of_type(type)
    for f in fields:
        if "key" in f and f["key"] == key:
            return f["label"]
    return key

def get_fields_from_labels(labels, type):
    result=[]
    fields = get_fields_of_type(type)
    if fields is not None:
        for l in labels:
            for f in fields:
                if f['label'] == l:
                    result.append(f['field'])
                    break
    return result
